unit unit_uccthread;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes;

type
  TUCCThread = class(TThread)
  protected
    procedure Execute; override;
    procedure Compress;
    function WinExecAndWait32(FileName: string; Visibility: integer): integer;
  public
    filename : string;
    ucc : string;
    threadid: integer;
    returnvalue : integer;
    procid : cardinal;
    constructor Create(fn, uccpath: string);
  end;

implementation

constructor TUCCThread.Create(fn, uccpath: string);
begin
  filename := fn;
  ucc := uccpath;
  inherited Create(True);
end;

procedure TUCCThread.Execute;
begin
  Compress;
end;

procedure TUCCThread.Compress;
begin
  returnvalue := WinExecAndWait32(ucc+' compress "'+filename+'"',SW_HIDE);
end;

function TUCCThread.WinExecAndWait32(FileName: string; Visibility: integer): integer;
 { returns -1 if the Exec failed, otherwise returns the process' exit
   code when the process terminates }
var
  zAppName: array[0..512] of char;
  zCurDir: array[0..255] of char;
  WorkDir: string;
  StartupInfo: TStartupInfo;
  ProcessInfo: TProcessInformation;
begin
  StrPCopy(zAppName, FileName);
  GetDir(0, WorkDir);
  StrPCopy(zCurDir, WorkDir);
  FillChar(StartupInfo, Sizeof(StartupInfo), #0);
  StartupInfo.cb := Sizeof(StartupInfo);
  StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow := Visibility;
  if not CreateProcess(nil,
    zAppName, { pointer to command line string }
    nil, { pointer to process security attributes }
    nil, { pointer to thread security attributes }
    False, { handle inheritance flag }
    CREATE_NEW_CONSOLE or { creation flags }
    NORMAL_PRIORITY_CLASS or CREATE_NEW_PROCESS_GROUP,
    nil, { pointer to new environment block }
    nil, { pointer to current directory name }
    StartupInfo, { pointer to STARTUPINFO }
    ProcessInfo) then { pointer to PROCESS_INF }
    Result := -1
  else
  begin
    procid := ProcessInfo.hProcess;
    WaitforSingleObject(ProcessInfo.hProcess, INFINITE);
    GetExitCodeProcess(ProcessInfo.hProcess, DWORD(Result));
    CloseHandle(ProcessInfo.hProcess);
    CloseHandle(ProcessInfo.hThread);
  end;
end;

end.
